﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.OleDb;

namespace Estacionamento_BD
{
    class Program
    {

        public static class Access
        {
            public static OleDbConnection AbrirConexao()
            {
                return new OleDbConnection(@"Provider=Microsoft.Jet.OleDb.4.0;Data Source=F:\Sergio16GB\aulas 17\Ituiutaba\1 SEM\EC\POO\Estacionamento_BD\Estacionamento_BD\Estacionamento.mdb");                      
            }
        }

        public class Estacionamento
        {
            private string placa_veiculo { get; set; }
            private string marca_veiculo { get; set; }
            private string modelo_veiculo { get; set; }
            private string tipo_veiculo { get; set; }
            private int hora_entrada { get; set; }
            private int minuto_entrada { get; set; }
            private int hora_saida { get; set; }
            private int minuto_saida { get; set; }

            public void ZerarVaga(int qualvaga)
            {
                OleDbConnection cnn = Access.AbrirConexao();
                OleDbCommand cmd = new OleDbCommand();
                cmd.Connection = cnn;
                cmd.CommandText = "Update vagas set hora_entrada=-1,hora_saida=-1,minuto_entrada=-1,minuto_saida=-1 where vaga=" + qualvaga;
                try
                {
                    cnn.Open();
                    cmd.ExecuteNonQuery();
                    cnn.Close();
                }
                catch (OleDbException e)
                {
                    Console.WriteLine("Erro: {0}", e.Errors[0].Message);
                }
            }

            public void PreencherDadosVeiculo()
            {
                int opc;
                Console.Write("Informe a placa do veículo: ");
                this.placa_veiculo = Console.ReadLine();
                Console.Write("Informe a marca do veículo: ");
                this.marca_veiculo = Console.ReadLine();
                Console.Write("Informe o modelo do veículo: ");
                this.modelo_veiculo = Console.ReadLine();
                Console.Write("Escolha:\n1 - Veículo de Passeio\n2 - Veículo Utilitário\n3 - Ônibus\n4 - Caminhão\nQual opção? ");
                do
                {
                    opc = Convert.ToInt32(Console.ReadLine());
                    if (opc < 1 || opc > 4)
                        Console.Write("Escolha:\n1 - Veículo de Passeio\n2 - Veículo Utilitário\n3 - Ônibus\n4 - Caminhão\nQual opção? ");
                    else
                    {
                        if (opc == 1)
                            this.tipo_veiculo = "passeio";
                        if (opc == 2)
                            this.tipo_veiculo = "utilitario";
                        if (opc == 3)
                            this.tipo_veiculo = "onibus";
                        if (opc == 4)
                            this.tipo_veiculo = "caminhao";
                     }
                } while(opc < 1 || opc > 4);
                //chamar método de preencher hora e minuto
                DadosEntrada();
            }

            public void DadosEntrada()
            {
                Console.Write("Digite a hora de entrada: ");
                this.hora_entrada = Convert.ToInt32(Console.ReadLine());
                Console.Write("Digite os minutos de entrada: ");
                this.minuto_entrada = Convert.ToInt32(Console.ReadLine());

            }

            public void DadosSaida()
            {
                Console.Write("Digite a hora de saída: ");
                this.hora_saida = Convert.ToInt32(Console.ReadLine());
                Console.Write("Digite os minutos de saída: ");
                this.minuto_saida = Convert.ToInt32(Console.ReadLine());
                if (this.hora_saida < this.hora_entrada)
                {
                    Console.WriteLine("A hora de entrada não pode ser maior do que a hora de saída");
                    DadosSaida();
                }
                else
                {
                    if (this.hora_saida == this.hora_entrada)
                    {
                        if (this.minuto_saida <= this.minuto_entrada)
                        {
                            Console.WriteLine("Os minutos de entrada não pode ser maior ou igual ao minuto de saída");
                            DadosSaida();
                        }
                    }
                }
               // Console.WriteLine("Saida: {0}:{1}", this.hora_saida,this.minuto_saida);
            }

            public int CalculaTempo()
            {
                int entrada;
                int saida;

                entrada = this.hora_entrada * 60 + this.minuto_entrada;
                saida = this.hora_saida * 60 + this.minuto_saida;
                return saida - entrada;
            }

            public double ValorAPagar(int tempo)
            {
                int htotal;
                double vtotal = 0;

                htotal = (tempo / 60);
                if (tempo % 60 > 0)
                    htotal++;
                if(this.tipo_veiculo == "passeio")
                    vtotal=3.5 * htotal ;
                if (this.tipo_veiculo == "utilitario")
                    vtotal = 4.5 * htotal;
                if (this.tipo_veiculo == "onibus")
                    vtotal = 7.5 * htotal;
                if (this.tipo_veiculo == "caminhao")
                    vtotal = 10 * htotal;
                return vtotal;
            }

            public void EstacionaVeiculoBanco(int qualvaga)
            {
                OleDbConnection conexao = Access.AbrirConexao();
                OleDbCommand cmd = new OleDbCommand();
                cmd.Connection = conexao;
                cmd.CommandText = "Update vagas set placa_veiculo = \'" + this.placa_veiculo  + "\',marca_veiculo = \'" + this.marca_veiculo + "\',modelo_veiculo = \'" + this.modelo_veiculo + "\',tipo_veiculo =\'" + this.tipo_veiculo + "\', hora_entrada = " + this.hora_entrada + ", minuto_entrada="+this.minuto_entrada + " where vaga = " + qualvaga;
                try
                {
                    conexao.Open();
                    cmd.ExecuteNonQuery();
                    conexao.Close();
                    Console.WriteLine("Veículo {0} - {2} - estacionado na vaga {1}", this.placa_veiculo, qualvaga.ToString(),this.tipo_veiculo);

                }
                catch (OleDbException e)
                {
                    Console.WriteLine("Erro: {0}", e.Errors[0].Message);
                }
            }

            public void RemoveVeiculoBanco(int qualvaga_)
            {
                OleDbConnection conexao = Access.AbrirConexao();
                OleDbCommand cmd = new OleDbCommand();

                cmd.Connection = conexao;
                cmd.CommandText = "Update vagas set hora_saida = " + this.hora_saida + ", minuto_saida=" + this.minuto_saida + " where vaga = " + qualvaga_;
                try
                {
                    conexao.Open();
                    cmd.ExecuteNonQuery();
                    conexao.Close();
                    Console.WriteLine("Veículo {0} - {2} - desocupou a vaga {1}", this.placa_veiculo, qualvaga_.ToString(),this.tipo_veiculo);
                    Console.WriteLine("Total a pagar: R$ {0}", this.ValorAPagar(this.CalculaTempo()).ToString());
                    this.ZerarVaga(qualvaga_);
                }
                catch (OleDbException e)
                {
                    Console.WriteLine("Erro: {0}", e.Errors[0].Message);
                }
            }
        }
            
        static void Main()
        {
            Estacionamento meu = new Estacionamento();
           
            string opc;
            int quevaga; 

            OleDbConnection conexao = Access.AbrirConexao();
            OleDbCommand cmd = new OleDbCommand();
            OleDbDataReader resultado;
            cmd.Connection = conexao;
            cmd.CommandText = "Update vagas set hora_entrada = -1, minuto_entrada=-1,hora_saida=-1,minuto_saida=-1";
            
            try
            {
                conexao.Open();
                cmd.ExecuteNonQuery();
                conexao.Close();
            }
            catch (OleDbException e)
            {
                Console.WriteLine("Erro: {0}", e.Errors[0].Message);
            }
            do {
                Console.WriteLine("\t\t\n\nMenu de Opções do Estacionamento.");
                Console.WriteLine("\t\t1 - Entrada de veículo\n\t\t2 - Saída de veículo\n\t\t3 - Sair");
                Console.Write("Escolha uma opção: ");
                opc = Console.ReadLine();
                switch (opc)
                { 
                    case "1":
                        cmd.CommandText = "Select vaga from vagas where hora_entrada=-1 and minuto_entrada=-1";
                        try
                        {
                            conexao.Open();
                            resultado = cmd.ExecuteReader();
                            if (resultado.HasRows)
                            {
                                Console.WriteLine("As vagas disponíveis para estacionar veículos são: ");
                                while (resultado.Read())
                                {
                                    Console.Write("{0}\t", resultado[0].ToString());
                                }
                                resultado.Close();
                                conexao.Close();
                                Console.Write("\nQual vaga deseja ocupar? ");
                                quevaga = Convert.ToInt32(Console.ReadLine());
                                cmd.CommandText = "Select * from vagas where hora_entrada=-1 and minuto_entrada=-1 and vaga=" + quevaga;
                                conexao.Open();
                                resultado = cmd.ExecuteReader();
                                if (resultado.HasRows)
                                {
                                    meu.PreencherDadosVeiculo();
                                    meu.EstacionaVeiculoBanco(quevaga);
                                }
                                else
                                {
                                    Console.WriteLine("Esta vaga não está disponível ou não existe");
                                }
                            }
                            else
                            {
                                Console.WriteLine("Não existe nenhuma vaga disponível no momento!");
                            }
                            conexao.Close();
                        }
                        catch (OleDbException e)
                        {
                            Console.WriteLine("Erro: {0}", e.Errors[0].Message);
                        }
                        break;

                    case "2":
                        cmd.CommandText = "Select vaga from vagas where hora_saida=-1 and minuto_saida=-1 and hora_entrada >= 0 and minuto_entrada >= 0";
                        try
                        {
                            conexao.Open();
                            resultado = cmd.ExecuteReader();
                            if (resultado.HasRows)
                            {
                                Console.WriteLine("As vagas com veículos para saídas são: ");
                                while (resultado.Read())
                                {
                                    Console.Write("{0}\t", resultado[0].ToString());
                                }
                                resultado.Close();
                                conexao.Close();
                                Console.Write("\nQual vaga deseja fechar? ");
                                quevaga = Convert.ToInt32(Console.ReadLine());
                                cmd.CommandText = "Select * from vagas where hora_entrada>=0 and minuto_entrada>=0 and hora_saida=-1 and minuto_saida=-1 and vaga=" + quevaga;
                                conexao.Open();
                                resultado = cmd.ExecuteReader();
                                if (resultado.HasRows)
                                {
                                    meu.DadosSaida();
                                    meu.RemoveVeiculoBanco(quevaga);
                                }
                                else
                                {
                                    Console.WriteLine("Esta vaga não está disponível ou não existe");
                                }
                            }
                            else
                            {
                                Console.WriteLine("Não existe nenhuma vaga disponível no momento!");
                            }
                            conexao.Close();
                        }
                        catch (OleDbException e)
                        {
                            Console.WriteLine("Erro: {0}", e.Errors[0].Message);
                        }
                        break;
                        break;
                    case "3":

                        break;
                    default:
                        Console.WriteLine("Opção inválida");
                        break;
                }

            } while (opc!="3");
            
            Console.ReadKey();
        }
    }
}
